#ifndef BISON_CF_PARSE_TAB_H
# define BISON_CF_PARSE_TAB_H

#ifndef YYSTYPE
typedef union {
  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	END	257
# define	CLI_MARKER	258
# define	INVALID_TOKEN	259
# define	GEQ	260
# define	LEQ	261
# define	NEQ	262
# define	AND	263
# define	OR	264
# define	NUM	265
# define	ENUM	266
# define	RTRID	267
# define	IPA	268
# define	SYM	269
# define	TEXT	270
# define	PREFIX_DUMMY	271
# define	DEFINE	272
# define	ON	273
# define	OFF	274
# define	YES	275
# define	NO	276
# define	LOG	277
# define	SYSLOG	278
# define	ALL	279
# define	DEBUG	280
# define	TRACE	281
# define	INFO	282
# define	REMOTE	283
# define	WARNING	284
# define	ERROR	285
# define	AUTH	286
# define	FATAL	287
# define	BUG	288
# define	STDERR	289
# define	CONFIGURE	290
# define	DOWN	291
# define	KERNEL	292
# define	PERSIST	293
# define	SCAN	294
# define	TIME	295
# define	LEARN	296
# define	DEVICE	297
# define	ASYNC	298
# define	TABLE	299
# define	ROUTER	300
# define	ID	301
# define	PROTOCOL	302
# define	PREFERENCE	303
# define	DISABLED	304
# define	DIRECT	305
# define	INTERFACE	306
# define	IMPORT	307
# define	EXPORT	308
# define	FILTER	309
# define	NONE	310
# define	STATES	311
# define	ROUTES	312
# define	FILTERS	313
# define	PASSWORD	314
# define	FROM	315
# define	PASSIVE	316
# define	TO	317
# define	EVENTS	318
# define	PACKETS	319
# define	PROTOCOLS	320
# define	INTERFACES	321
# define	PRIMARY	322
# define	STATS	323
# define	COUNT	324
# define	FOR	325
# define	COMMANDS	326
# define	PREIMPORT	327
# define	SHOW	328
# define	STATUS	329
# define	SUMMARY	330
# define	ROUTE	331
# define	SYMBOLS	332
# define	DUMP	333
# define	RESOURCES	334
# define	SOCKETS	335
# define	NEIGHBORS	336
# define	ATTRIBUTES	337
# define	ECHO	338
# define	DISABLE	339
# define	ENABLE	340
# define	RESTART	341
# define	FUNCTION	342
# define	PRINT	343
# define	PRINTN	344
# define	UNSET	345
# define	RETURN	346
# define	ACCEPT	347
# define	REJECT	348
# define	QUITBIRD	349
# define	INT	350
# define	BOOL	351
# define	IP	352
# define	PREFIX	353
# define	PAIR	354
# define	SET	355
# define	STRING	356
# define	BGPMASK	357
# define	BGPPATH	358
# define	CLIST	359
# define	IF	360
# define	THEN	361
# define	ELSE	362
# define	CASE	363
# define	TRUE	364
# define	FALSE	365
# define	GW	366
# define	NET	367
# define	MASK	368
# define	SOURCE	369
# define	SCOPE	370
# define	CAST	371
# define	DEST	372
# define	LEN	373
# define	DEFINED	374
# define	ADD	375
# define	DELETE	376
# define	CONTAINS	377
# define	RESET	378
# define	PREPEND	379
# define	MATCH	380
# define	EMPTY	381
# define	WHERE	382
# define	EVAL	383
# define	BGP	384
# define	LOCAL	385
# define	NEIGHBOR	386
# define	AS	387
# define	HOLD	388
# define	CONNECT	389
# define	RETRY	390
# define	KEEPALIVE	391
# define	MULTIHOP	392
# define	STARTUP	393
# define	VIA	394
# define	NEXT	395
# define	HOP	396
# define	SELF	397
# define	DEFAULT	398
# define	PATH	399
# define	METRIC	400
# define	START	401
# define	DELAY	402
# define	FORGET	403
# define	WAIT	404
# define	AFTER	405
# define	BGP_PATH	406
# define	BGP_LOCAL_PREF	407
# define	BGP_MED	408
# define	BGP_ORIGIN	409
# define	BGP_NEXT_HOP	410
# define	BGP_ATOMIC_AGGR	411
# define	BGP_AGGREGATOR	412
# define	BGP_COMMUNITY	413
# define	ADDRESS	414
# define	OSPF	415
# define	AREA	416
# define	OSPF_METRIC1	417
# define	OSPF_METRIC2	418
# define	OSPF_TAG	419
# define	RFC1583COMPAT	420
# define	STUB	421
# define	TICK	422
# define	COST	423
# define	RETRANSMIT	424
# define	HELLO	425
# define	TRANSMIT	426
# define	PRIORITY	427
# define	DEAD	428
# define	NONBROADCAST	429
# define	POINTOPOINT	430
# define	TYPE	431
# define	SIMPLE	432
# define	AUTHENTICATION	433
# define	STRICT	434
# define	ELIGIBLE	435
# define	POLL	436
# define	NETWORKS	437
# define	HIDDEN	438
# define	PIPE	439
# define	PEER	440
# define	RIP	441
# define	INFINITY	442
# define	PORT	443
# define	PERIOD	444
# define	GARBAGE	445
# define	TIMEOUT	446
# define	PASSWORDS	447
# define	MODE	448
# define	BROADCAST	449
# define	MULTICAST	450
# define	QUIET	451
# define	NOLISTEN	452
# define	VERSION1	453
# define	PLAINTEXT	454
# define	MD5	455
# define	HONOR	456
# define	NEVER	457
# define	ALWAYS	458
# define	RIP_METRIC	459
# define	RIP_TAG	460
# define	STATIC	461
# define	DROP	462
# define	PROHIBIT	463


extern YYSTYPE cf_lval;

#endif /* not BISON_CF_PARSE_TAB_H */
