The System screen lets you enable a variety of the Router's general features, from restoring factory defaults to enabling its remote management capability.  

 
Restore Factory Defaults

     

Click the Yes button to reset all configuration settings to their default values, and then click the Apply button. Note: Any settings you have saved will be lost when the default settings are restored. This feature is disabled by default.  
Upgrade Firmware

     

Click the Upgrade button to load new firmware onto the Router. New firmware versions are posted at www.linksys.com and can be downloaded for free. If the Router is not experiencing difficulties, then there is no need to download a more recent firmware version, unless that version has a new feature that you want to use.

 

Note: When you upgrade the Router's firmware, you may lose its configuration settings, so make sure you write down the Router settings before you upgrade its firmware.

 

To upgrade the Router's firmware:

1.      Download the firmware upgrade file from the Linksys website. 

2.      Extract the firmware upgrade file.

3.      Click the  Upgrade button.

4.      On the  Firmware Upgrade screen, click the Browse button to find the firmware upgrade file.

5.      Double-click the firmware upgrade file.

6.      Click the  Upgrade button, and follow the on-screen instructions. 

 

Note: Do not power off the Router or press the Reset button while the firmware is being upgraded.  
Multicast Pass-Through    

IP Multicasting occurs when a single data transmission is sent to multiple recipients at the same time.  Using the Multicast Pass-Through feature, the Router allows IP multicast packets to be forwarded to the appropriate computers. Keep the default setting, Enable, to support the feature, or select Disable to disable it.  
MAC Cloning    

The Router's MAC address is a 12-digit code assigned to a unique piece of hardware for identification. Some ISPs require that you register the MAC address of your network card/adapter, which was connected to your cable or DSL modem during installation. If your ISP requires MAC address registration, find your adapter MAC address by following the instructions for your PC operating system.

 

For Windows 98 and Millennium:

1.      Click the  Start button, and select Run. 

2.      Type winipcfg in the field provided, and press the  OK key.

3.      Select the Ethernet adapter you are using.

4.      Click More Info.

5.      Write down your adapter's MAC address.

 

For Windows 2000 and XP:

1.      Click the  Start button, and select Run. 

2.      Type cmd in the field provided, and press the  OK key.

3.      At the command prompt, run  ipconfig /all, and look at your adapter's physical address.

4.      Write down your adapter's MAC address.

 

To clone your network adapter's MAC address onto the Router and avoid calling your ISP to change the registered MAC address, follow these instructions:

 

1.      Select Enable.

2.      Enter your adapter's MAC address in the MAC Address field. 

3.      Click the  Apply button. 

 

To disable MAC address cloning, keep the default setting,  Disable.  
Remote Management

     

This feature allows you to manage your Router from a remote location, via the Internet.  To disable this feature, keep the default setting, Disable. To enable this feature, select Enable, and use the specified port (default is 8080) on your PC to remotely manage the Router. You must also change the Router's default password to one of your own, if you haven already. A unique password will increase security.

 

To remotely manage the Router, enter http://xxx.xxx.xxx.xxx:8080 (the x's represent the Router's Internet IP address, and 8080 represents the specified port) in your web browser's Address field. You will be asked for the Router's password. After successfully entering the password, you will be able to access the Router's web-based utility.

 

Note: If the Remote Management feature is enabled, anyone who knows the Router's Internet IP address and password will be able to alter the Router's settings.  
MTU    

MTU is the Maximum Transmission Unit. It specifies the largest packet size permitted for Internet transmission. Keep the default setting, Auto, to have the Router select the best MTU for your Internet connection. To specify a MTU size, select Manual, and enter the value desired (default is  1400).  You should leave this value in the 1200 to 1500 range.  
Log    

The Router can keep logs of all incoming or outgoing traffic for your Internet connection. To keep activity logs, select Enable. To see a temporary log of the Router's most recent incoming traffic, click the Incoming Access Log button. To see a temporary log of the Router's most recent outgoing traffic, click the Outgoing Access Log button.  

 

Check all the values and click Apply to save your settings. Click Cancel to cancel your unsaved changes.

 

                                                                        
