The Setup screen is the first screen you will see when accessing the Router. Most users will be able to configure the Router and get it working properly using only the settings on this screen. Some Internet Service Providers (ISPs) will require that you enter specific information, such as User Name, Password, IP Address, Default Gateway Address, or DNS IP Address. This information can be obtained from your ISP, if required.

 

Note: After you have configured these settings, you should set a new password for the Router using the Security screen. This will increase security, protecting the Router from unauthorized changes. All users who try to access the Router web-based utility or Setup Wizard will be prompted for the Router's password.

  
Time Zone    

Select the time zone for your location. If your location experiences daylight savings, leave the checkmark in the box next to Automatically adjust clock for daylight saving changes.  
MTU    

MTU is the Maximum Transmission Unit. It specifies the largest packet size permitted for Internet transmission. Keep the default setting, Auto, to have the Router select the best MTU for your Internet connection. To specify a MTU size, select Manual, and enter the value desired (default is  1400).  You should leave this value in the 1200 to 1500 range.  

 

Internet

 
Host Name     

This entry is necessary for some ISPs and can be provided by them.  
Domain Name    

This entry is necessary for some ISPs and can be provided by them.  
Configuration Type    

The Router supports four connection types:

 

Automatic Configuration DHCP

Static IP

PPPoE (Point-to-Point Protocol over Ethernet)

PPTP (Point-to-Point Tunneling Protocol)

 

These types can be selected from the drop-down menu next to Internet Connection. The information required and available features will differ depending on what kind of connection type you select. Some descriptions of this information are included here:
  * Internet IP Address and Subnet Mask 
This is the Router's IP Address and Subnet Mask as seen by external users on the Internet (including your ISP). If your Internet connection requires a static IP address, then your ISP will provide you with a Static IP Address and Subnet Mask.
  * Default Gateway 
Your ISP will provide you with the Gateway IP Address.
  * DNS (Domain Name Server) 
Your ISP will provide you with at least one DNS IP Address.
  * User Name and Password 
Enter the User Name and Password you use when logging onto your ISP through a PPPoE or PPTP connection.
  * Connect on Demand 
You can configure the Router to disconnect your Internet connection after a specified period of inactivity (Max Idle Time). If your Internet connection has been terminated due to inactivity, Connect on Demand enables the Router to automatically re-establish your connection as soon as you attempt to access the Internet again. If you wish to activate Connect on Demand, click the radio button. If you want your Internet connection to remain active at all times, enter 0 in the Max Idle Time field. Otherwise, enter the number of minutes you want to have elapsed before your Internet connection terminates.
  * Keep Alive Option  
This option keeps you connected to the Internet indefinitely, even when your connection sits idle. To use this option, click the radio button next to Keep Alive. The default Redial Period is 30 seconds (in other words, the Router will check the Internet connection every 30 seconds). 

 

Note: Some cable providers require a specific MAC address for connection to the Internet. To learn more about this, click the System tab. Then click the Help button, and read about the MAC Cloning feature.  

 

LAN

 
IP Address and Subnet Mask    

This is the Router IP Address and Subnet Mask as seen on the internal LAN. The default value is 192.168.1.1 for IP Address and 255.255.255.0 for Subnet Mask.  

 

DHCP

@
DHCP Server

     

Keep the default, Enable, to enable the Router' DHCP server option. If you already have a DHCP server on your network or you do not want a DHCP server, then select Disable.  
Starting IP Address    

Enter a numerical value for the DHCP server to start with when issuing IP addresses. Do not start with 192.168.1.1 (the IP address of the Router).  
Maximum Number of DHCP Users    

Enter the maximum number of PCs that you want the DHCP server to assign IP addresses to. The absolute maximum is 253--possible if 192.168.1.2 is your starting IP address.  
Client Lease Time

     

The Client Lease Time is the amount of time a network user will be allowed connection to the Router with their current dynamic IP address. Enter the amount of time, in minutes, that the user will be "leased" this dynamic IP address.  
Static DNS 1-3 

     

The Domain Name System (DNS) is how the Internet translates domain or website names into Internet addresses or URLs. Your ISP will provide you with at least one DNS Server IP Address. If you wish to utilize another, enter that IP Address in one of these fields. You can enter up to three DNS Server IP Addresses here. The Router will utilize these for quicker access to functioning DNS servers.  
WINS

     

The Windows Internet Naming Service (WINS) manages each PC's interaction with the Internet. If you use a WINS server, enter that server's IP Address here. Otherwise, leave this blank.  

@

 Check all the values and click Save Settings to save your settings. Click Cancel Changes to cancel your unsaved changes. You can test the settings by connecting to the Internet. 

 

                                                                
