The Wireless screen allows you to customize data transmission settings. In most cases, the advanced settings on this screen should remain at their default values.

 
Authentication Type    

The default is set to Auto, which allows either Open System or Shared Key authentication to be used. For Open System authentication, the sender and the recipient do NOT use a WEP key for authentication. For Shared Key authentication, the sender and recipient use a WEP key for authentication. If you want to use only Shared Key authentication, then select Shared Key.   
Basic Rate

     

The default value is set to Default. Depending on the wireless mode you have selected, a default set of supported data rates will be selected. The default setting will ensure maximum compatibility with all devices. You may also choose to enable all data rates by selecting ALL. For compatibility with older Wireless-B devices, select 1-2Mbps.   
Transmission Rate

     

The default setting is Auto. The range is from 1 to 54Mbps. 

 

The rate of data transmission should be set depending on the speed of your wireless network. You can select from a range of transmission speeds, or keep the default setting, Auto, to have the Router automatically use the fastest possible data rate and enable the Auto-Fallback feature. Auto-Fallback will negotiate the best possible connection speed between the Router and a wireless client.  
CTS Protection Mode

     

The default value is set to Disabled. When set to Auto, a protection mechanism will ensure that your Wireless-B devices will connect to the Wireless-G Router when many Wireless-G devices are present. However, performance of your Wireless-G devices may be decreased.   
Frame Burst

     

The default value is Disabled. Frame burst allows packet bursting which will increase overall network speed though this is only recommended for approx 1-3 wireless clients, Anymore clients and there can be a negative result and throughput will be affected.   
Beacon Interval

     

The default value is 100. Enter a value between 1 and 65,535 milliseconds. The Beacon Interval value indicates the frequency interval of the beacon. A beacon is a packet broadcast by the Router to synchronize the wireless network. 50 Is recommended in Poor reception  
DTIM Interval

     

The default value is 1. This value, between 1 and 255 milliseconds, indicates the interval of the Delivery Traffic Indication Message (DTIM). A DTIM field is a countdown field informing clients of the next window for listening to broadcast and multicast messages. When the Router has buffered broadcast or multicast messages for associated clients, it sends the next DTIM with a DTIM Interval value.  Its clients hear the beacons and awaken to receive the broadcast and multicast messages.  
Fragmentation Threshold

     

This value should remain at its default setting of 2346. The range is 256-2346 bytes. It specifies the maximum size for a packet before data is fragmented into multiple packets. If you experience a high packet error rate, you may slightly increase the Fragmentation Threshold. Setting the Fragmentation Threshold too low may result in poor network performance. Only minor modifications of this value are recommended.  
RTS Threshold

     

This value should remain at its default setting of 2347. The range is 0-2347 bytes. 

 

Should you encounter inconsistent data flow, only minor modifications are recommended. If a network packet is smaller than the preset RTS threshold size, the RTS/CTS mechanism will not be enabled. The Router sends Request to Send (RTS) frames to a particular receiving station and negotiates the sending of a data frame. After receiving an RTS, the wireless station responds with a Clear to Send (CTS) frame to acknowledge the right to begin transmission.  
AP Isolation    

This default value is Off.  This setting isolates wireless clients so access to and from other wireless clients are stopped.  
TX Antenna    

This default value is Auto. values are Auto, Left, Right.  This is used in conjunction with external antennas to give them optimum performance.  
RX Antenna    

This default value is Auto. values are Auto, Left, Right.  this is used in conjunction with external antennas to give them optimum performance.  
Xmit Power    

This default value is 28mw This value ranges from 1 - 251 mw

 

A safe increase of up to 70 would be suitable for most users.  

 

Higher power settings are not recommended for users due to excess heat generated by the radio chipset, which can affect the life of the router.   
Afterburner    

This default value is Off.  This should only be used with WRT54GS Models and only in conjunction with other Linksys "GS" wireless clients that also support Linksys "Speedbooster" technology  
Wireless GUI Access    

This default value is Enabled.  The setting allows for access to the routers setup (GUI) from wireless clients. Disable this if you wish to block all wireless clients from accessing the setup pages.  
Preamble    

This default value is Long. values are short or long. If your wireless device supports the short preamble and you are having trouble getting it to communicate with other 802.11b devices, make sure that it is set to use the long preamble   

 
Wireless MAC Filters

     

The Wireless MAC Filters feature allows you to control which wireless-equipped PCs may or may not communicate with the Router's depending on their MAC addresses. To disable the Wireless MAC Filters feature, keep the default setting, Disable. To set up a filter, click Enable, and follow these instructions: 

 

1.      If you want to block specific wireless-equipped PCs from communicating with the Router, then keep the default setting, Prevent PCs listed from accessing the wireless network. If you want to allow specific wireless-equipped PCs to communicate with the Router, then click the radio button next to Permit only PCs listed to access the wireless network. 

 

2.      Click the Edit MAC Filter List button. Enter the appropriate MAC addresses into the  MAC fields.

Note: For each MAC field, the MAC address should be entered in this format: xxxxxxxxxxxx (the x's represent the actual characters of the MAC address).

 

3.      Click the Save Settings button to save your changes. Click the Cancel Changes button to cancel your unsaved changes. Click the Close button to return to the Advanced Wireless screen without saving changes.  

 

Wireless

 
Wireless Mode    

AP mode: This is the default mode.  

 

Client mode: This mode turns the WRT54G/GS into a wireless client (ie a wirless PCI card of PCMCIA card) this in turn connects to a Wireless access point  The client is isolated from other Wireless clients  Also only one ethernet device can be connected though it could be a Router in AP mode

 

Ad-Hoc mode:  this of for peer to peer wireless connections  
Mode    

If you have Wireless-G and 802.11b devices in your network, then keep the default setting, Mixed. If you have only Wireless-G devices, select G-Only. If you want to disable wireless networking, select Disable. If you would like to limit your network to only 802.11b devices, then select B-Only.   
SSID    

The SSID is the network name shared among all devices in a wireless network. The SSID must be identical for all devices in the wireless network. It is case-sensitive and must not exceed 32 alphanumeric characters, which may be any keyboard character. Make sure this setting is the same for all devices in your wireless network. For added security, Linksys recommends that you change the default SSID (linksys) to a unique name of your choice.  
Channel    

Select the appropriate channel from the list provided to correspond with your network settings, between 1 and 11 (in North America). All devices in your wireless network must use the same channel in order to function correctly.  
SSID Broadcast    

Default is Enabled When wireless clients survey the local area for wireless networks to associate with, they will detect the SSID broadcast by the Router. To broadcast the Router SSID, keep the default setting, Enable. If you do not want to broadcast the Router SSID, then select Disable.  

 

Check all the values and click Save Settings to save your settings. Click Cancel Changes to cancel your unsaved changes.

 

                                                                    
