#ifdef HAVE_WOL

#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <bcmnvram.h>
#include <shutils.h>
#include <snmp.h>

#define WOL_INTERVAL 15

int wol_run(void)
{
	int ret = 0;
	pid_t pid;

	char *macs = NULL;
	char passwd_param[32] = {0};
	char *passwd = NULL;
	char hostname_param[32] = {0};
	char *hostname = NULL;
	char *wol_argv[] = { "/usr/sbin/wol", macs, passwd_param, passwd, hostname_param, hostname, NULL};

	if (nvram_match("wol_enable", "0"))
		return 0;

	/* Most of time it goes to sleep */
	while(nvram_match("wol_enable", "1"))
	{
	  int interval = 0;

	  interval = atoi(nvram_safe_get("wol_interval")) > WOL_INTERVAL ? atoi(nvram_safe_get("wol_interval")) : WOL_INTERVAL;

	  if(strlen(nvram_get("wol_passwd")) <= 0)
		passwd_param[0]=0;
	  else
	  	strcpy(passwd_param, "--passwd");

	  if(strlen(nvram_get("wol_hostname")) <= 0)
		hostname_param[0]=0;
	  else
	  	strcpy(passwd_param, "--host");

	  passwd = nvram_safe_get("wol_passwd");
	  hostname = nvram_safe_get("wol_host");

	  ret = _eval(wol_argv, NULL, 0, &pid);

	  sleep(interval);
	}

	dprintf("done\n");

	return ret;
}

int wol_main(int argc, char **argv)
{
	/* Run it in the background */
	switch (fork()) {
	case -1:
		// can't fork
		exit(0);
		break;
	case 0:
		/* child process */
		// fork ok
		(void) setsid();
		break;
	default:
		/* parent process should just die */
		_exit(0);
	}

	wol_run();

	return 0;
} // end main

int stop_wol(void)
{
	int ret;

        ret = eval("killall","-9","wol");

	dprintf("done\n");

	return ret ;
}

int start_wol(void)
{
	int ret;
	pid_t pid;
	char *wol_argv[] = { 	"wol",
				NULL
		    	   };

	stop_wol();

	if( nvram_match("wol_enable", "0") )
	    return 0;

        ret = _eval(wol_argv, NULL, 0, &pid);

        return ret;
}

#endif /* HAVE_WOL */
